//   NOTE: this is a machine generated file--editing not recommended
//
// sm_x509ce.h - class definitions for ASN.1 module CertificateExtensions
//
//   This file was generated by snacc on Tue Mar 31 09:23:43 1998
//   UBC snacc by Mike Sample
//   A couple of enhancements made by IBM European Networking Center

#ifndef _sm_x509ce_h_
#define _sm_x509ce_h_


//------------------------------------------------------------------------------
// class declarations:

class KeyUsage;
class CRLReason;
class ReasonFlags;
class PolicyQualifierInfo;
class AttributesSyntax;
class DistributionPointName;
class PolicyMappingsSyntaxSeq;
class PolicyInformationSeqOf;
class PolicyInformation;
class GeneralSubtree;
class DistributionPoint;
class CertificatePoliciesSyntax;
class GeneralSubtrees;
class AuthorityKeyIdentifier;
class PrivateKeyUsagePeriod;
class PolicyMappingsSyntax;
class SupportedAlgorithm;
class BasicConstraintsSyntax;
class NameConstraintsSyntax;
class PolicyConstraintsSyntax;
class CertPolicySet;
class CRLDistPointsSyntax;
class IssuingDistPointSyntax;

//------------------------------------------------------------------------------
// class definitions:

typedef enum CertificateExtensionsAnyId
{

} CertificateExtensionsAnyId;


/* OCTET STRING */
typedef AsnOcts KeyIdentifier;

/* BIT STRING { digitalSignature (0), nonRepudiation (1), keyEncipherment (2), dataEncipherment (3), keyAgreement (4), keyCertSign (5), cRLSign (6), encipherOnly (7), decipherOnly (8) }  */
class KeyUsage: public AsnBits
{
public:
			KeyUsage(): AsnBits() {}
			KeyUsage (const size_t bits): AsnBits (bits) {}
			KeyUsage (const char *str, const size_t bitLen): AsnBits (str, bitLen) {}
			KeyUsage (const AsnBits &b): AsnBits (b) {}
  enum
  {
    digitalSignature = 0,
    nonRepudiation = 1,
    keyEncipherment = 2,
    dataEncipherment = 3,
    keyAgreement = 4,
    keyCertSign = 5,
    cRLSign = 6,
    encipherOnly = 7,
    decipherOnly = 8
  };
};


/* OBJECT IDENTIFIER */
typedef AsnOid KeyPurposeId;

/* OBJECT IDENTIFIER */
typedef AsnOid CertPolicyId;

/* INTEGER (0..MAX) */
typedef AsnInt BaseDistance;

/* INTEGER (0..MAX) */
typedef AsnInt SkipCerts;

/* INTEGER (0..MAX) */
typedef AsnInt CRLNumber;

/* ENUMERATED { unspecified (0), keyCompromise (1), cACompromise (2), affiliationChanged (3), superseded (4), cessationOfOperation (5), certificateHold (6), removeFromCRL (8) }  */
class CRLReason: public AsnEnum
{
public:
			CRLReason(): AsnEnum() {}
			CRLReason (int i): AsnEnum (i) {}
  enum
  {
    unspecified = 0,
    keyCompromise = 1,
    cACompromise = 2,
    affiliationChanged = 3,
    superseded = 4,
    cessationOfOperation = 5,
    certificateHold = 6,
    removeFromCRL = 8
  };
};


/* OBJECT IDENTIFIER */
typedef AsnOid HoldInstruction;

/* BIT STRING { unused (0), keyCompromise (1), caCompromise (2), affiliationChanged (3), superseded (4), cessationOfOperation (5), certificateHold (6) }  */
class ReasonFlags: public AsnBits
{
public:
			ReasonFlags(): AsnBits() {}
			ReasonFlags (const size_t bits): AsnBits (bits) {}
			ReasonFlags (const char *str, const size_t bitLen): AsnBits (str, bitLen) {}
			ReasonFlags (const AsnBits &b): AsnBits (b) {}
  enum
  {
    unused = 0,
    keyCompromise = 1,
    caCompromise = 2,
    affiliationChanged = 3,
    superseded = 4,
    cessationOfOperation = 5,
    certificateHold = 6
  };
};


class PolicyQualifierInfo: public AsnType
{
public:
  AsnOid		policyQualifierId;
  AsnAny		*qualifier;

			PolicyQualifierInfo();
			PolicyQualifierInfo (const PolicyQualifierInfo &);
			~PolicyQualifierInfo();
  AsnType		*Clone() const;

  PolicyQualifierInfo		&operator = (const PolicyQualifierInfo &);
  AsnLen		BEncContent (BUF_TYPE b);
  void			BDecContent (BUF_TYPE b, AsnTag tag, AsnLen elmtLen, AsnLen &bytesDecoded, ENV_TYPE env);

  AsnLen		BEnc (BUF_TYPE b);
  void			BDec (BUF_TYPE b, AsnLen &bytesDecoded, ENV_TYPE env);
  int			BEncPdu (BUF_TYPE b, AsnLen &bytesEncoded);
  int			BDecPdu (BUF_TYPE b, AsnLen &bytesDecoded);

  void		Print (ostream &os) const;
};


class AttributesSyntax: public AsnType
{
protected:
  unsigned long int	count;
  struct AsnListElmt
  {
    AsnListElmt	*next;
    AsnListElmt	*prev;
    Attribute	*elmt;
  }			*first, *curr, *last;

public:
			AttributesSyntax() { count = 0; first = curr = last = NULL; }
			AttributesSyntax (const AttributesSyntax &);
			~AttributesSyntax();
  AsnType		*Clone() const;

  AttributesSyntax		&operator = (const AttributesSyntax &);
  void		SetCurrElmt (unsigned long int index);
  unsigned long int	GetCurrElmtIndex();
  void		SetCurrToFirst() { curr = first; }
  void		SetCurrToLast()  { curr = last; }
  // reading member fcns
  int			Count() const	{ return count; }
  // NOTE: if your compiler complains about these NULLs, its definition of NULL is broken (and you better change it there!)
  Attribute	*First() const	{ return count > 0 ? first->elmt : NULL; }
  Attribute	*Last() const	{ return count > 0 ? last->elmt : NULL; }
  Attribute	*Curr() const	{ return curr ? curr->elmt : NULL; }
  Attribute	*Next() const	{ return curr && curr->next ? curr->next->elmt : NULL; }
  Attribute	*Prev() const	{ return curr && curr->prev ? curr->prev->elmt : NULL; }

  // routines that move the curr elmt
  Attribute	*GoNext() { if (curr) curr = curr->next; return Curr(); }
  Attribute	*GoPrev() { if (curr) curr = curr->prev; return Curr(); }

  // write & alloc fcns - returns new elmt
  Attribute	*Append();  // add elmt to end of list
  Attribute	*Prepend(); // add elmt to beginning of list
  Attribute	*InsertBefore(); //insert elmt before current elmt
  Attribute	*InsertAfter(); //insert elmt after current elmt

  // write & alloc & copy - returns list after copying elmt
  AttributesSyntax	&AppendCopy (Attribute &elmt);  // add elmt to end of list
  AttributesSyntax	&PrependCopy (Attribute &elmt); // add elmt to beginning of list
  AttributesSyntax	&InsertBeforeAndCopy (Attribute &elmt); //insert elmt before current elmt
  AttributesSyntax	&InsertAfterAndCopy (Attribute &elmt); //insert elmt after current elmt

  // removing the current elmt from the list
  void		RemoveCurrFromList();

  // encode and decode routines    
  AsnLen		BEnc (BUF_TYPE b);
  void			BDec (BUF_TYPE b, AsnLen &bytesDecoded, ENV_TYPE env);
  AsnLen		BEncContent (BUF_TYPE b);
  void			BDecContent (BUF_TYPE b, AsnTag tag, AsnLen elmtLen, AsnLen &bytesDecoded, ENV_TYPE env);

  PDU_MEMBER_MACROS
  void		Print (ostream &os) const;
};


class DistributionPointName: public AsnType
{
public:
  enum ChoiceIdEnum
  {
     fullNameCid = 0,
     nameRelativeToCRLIssuerCid = 1
  };

  enum ChoiceIdEnum	choiceId;
  union
  {
     GeneralNames		*fullName;
     RelativeDistinguishedName		*nameRelativeToCRLIssuer;
  };


			DistributionPointName();
			DistributionPointName (const DistributionPointName &);
			~DistributionPointName();

  AsnType		*Clone() const;

  DistributionPointName		&operator = (const DistributionPointName &);
  AsnLen		BEncContent (BUF_TYPE b);
  void			BDecContent (BUF_TYPE b, AsnTag tag, AsnLen elmtLen, AsnLen &bytesDecoded, ENV_TYPE env);
  AsnLen		BEnc (BUF_TYPE b);
  void			BDec (BUF_TYPE b, AsnLen &bytesDecoded, ENV_TYPE env);
  int			BEncPdu (BUF_TYPE b, AsnLen &bytesEncoded);
  int			BDecPdu (BUF_TYPE b, AsnLen &bytesDecoded);

  void			Print (ostream &os) const;
};


class PolicyMappingsSyntaxSeq: public AsnType
{
public:
  CertPolicyId		issuerDomainPolicy;
  CertPolicyId		subjectDomainPolicy;

			PolicyMappingsSyntaxSeq();
			PolicyMappingsSyntaxSeq (const PolicyMappingsSyntaxSeq &);
			~PolicyMappingsSyntaxSeq();
  AsnType		*Clone() const;

  PolicyMappingsSyntaxSeq		&operator = (const PolicyMappingsSyntaxSeq &);
  AsnLen		BEncContent (BUF_TYPE b);
  void			BDecContent (BUF_TYPE b, AsnTag tag, AsnLen elmtLen, AsnLen &bytesDecoded, ENV_TYPE env);

  AsnLen		BEnc (BUF_TYPE b);
  void			BDec (BUF_TYPE b, AsnLen &bytesDecoded, ENV_TYPE env);
  int			BEncPdu (BUF_TYPE b, AsnLen &bytesEncoded);
  int			BDecPdu (BUF_TYPE b, AsnLen &bytesDecoded);

  void		Print (ostream &os) const;
};


class PolicyInformationSeqOf: public AsnType
{
protected:
  unsigned long int	count;
  struct AsnListElmt
  {
    AsnListElmt	*next;
    AsnListElmt	*prev;
    PolicyQualifierInfo	*elmt;
  }			*first, *curr, *last;

public:
			PolicyInformationSeqOf() { count = 0; first = curr = last = NULL; }
			PolicyInformationSeqOf (const PolicyInformationSeqOf &);
			~PolicyInformationSeqOf();
  AsnType		*Clone() const;

  PolicyInformationSeqOf		&operator = (const PolicyInformationSeqOf &);
  void		SetCurrElmt (unsigned long int index);
  unsigned long int	GetCurrElmtIndex();
  void		SetCurrToFirst() { curr = first; }
  void		SetCurrToLast()  { curr = last; }
  // reading member fcns
  int			Count() const	{ return count; }
  // NOTE: if your compiler complains about these NULLs, its definition of NULL is broken (and you better change it there!)
  PolicyQualifierInfo	*First() const	{ return count > 0 ? first->elmt : NULL; }
  PolicyQualifierInfo	*Last() const	{ return count > 0 ? last->elmt : NULL; }
  PolicyQualifierInfo	*Curr() const	{ return curr ? curr->elmt : NULL; }
  PolicyQualifierInfo	*Next() const	{ return curr && curr->next ? curr->next->elmt : NULL; }
  PolicyQualifierInfo	*Prev() const	{ return curr && curr->prev ? curr->prev->elmt : NULL; }

  // routines that move the curr elmt
  PolicyQualifierInfo	*GoNext() { if (curr) curr = curr->next; return Curr(); }
  PolicyQualifierInfo	*GoPrev() { if (curr) curr = curr->prev; return Curr(); }

  // write & alloc fcns - returns new elmt
  PolicyQualifierInfo	*Append();  // add elmt to end of list
  PolicyQualifierInfo	*Prepend(); // add elmt to beginning of list
  PolicyQualifierInfo	*InsertBefore(); //insert elmt before current elmt
  PolicyQualifierInfo	*InsertAfter(); //insert elmt after current elmt

  // write & alloc & copy - returns list after copying elmt
  PolicyInformationSeqOf	&AppendCopy (PolicyQualifierInfo &elmt);  // add elmt to end of list
  PolicyInformationSeqOf	&PrependCopy (PolicyQualifierInfo &elmt); // add elmt to beginning of list
  PolicyInformationSeqOf	&InsertBeforeAndCopy (PolicyQualifierInfo &elmt); //insert elmt before current elmt
  PolicyInformationSeqOf	&InsertAfterAndCopy (PolicyQualifierInfo &elmt); //insert elmt after current elmt

  // removing the current elmt from the list
  void		RemoveCurrFromList();

  // encode and decode routines    
  AsnLen		BEnc (BUF_TYPE b);
  void			BDec (BUF_TYPE b, AsnLen &bytesDecoded, ENV_TYPE env);
  AsnLen		BEncContent (BUF_TYPE b);
  void			BDecContent (BUF_TYPE b, AsnTag tag, AsnLen elmtLen, AsnLen &bytesDecoded, ENV_TYPE env);

  PDU_MEMBER_MACROS
  void		Print (ostream &os) const;
};


class PolicyInformation: public AsnType
{
public:
  CertPolicyId		policyIdentifier;
  PolicyInformationSeqOf		*policyQualifiers;

			PolicyInformation();
			PolicyInformation (const PolicyInformation &);
			~PolicyInformation();
  AsnType		*Clone() const;

  PolicyInformation		&operator = (const PolicyInformation &);
  AsnLen		BEncContent (BUF_TYPE b);
  void			BDecContent (BUF_TYPE b, AsnTag tag, AsnLen elmtLen, AsnLen &bytesDecoded, ENV_TYPE env);

  AsnLen		BEnc (BUF_TYPE b);
  void			BDec (BUF_TYPE b, AsnLen &bytesDecoded, ENV_TYPE env);
  int			BEncPdu (BUF_TYPE b, AsnLen &bytesEncoded);
  int			BDecPdu (BUF_TYPE b, AsnLen &bytesDecoded);

  void		Print (ostream &os) const;
};


class GeneralSubtree: public AsnType
{
public:
  GeneralName		*base;
  BaseDistance		*minimum;
  BaseDistance		*maximum;

			GeneralSubtree();
			GeneralSubtree (const GeneralSubtree &);
			~GeneralSubtree();
  AsnType		*Clone() const;

  GeneralSubtree		&operator = (const GeneralSubtree &);
  AsnLen		BEncContent (BUF_TYPE b);
  void			BDecContent (BUF_TYPE b, AsnTag tag, AsnLen elmtLen, AsnLen &bytesDecoded, ENV_TYPE env);

  AsnLen		BEnc (BUF_TYPE b);
  void			BDec (BUF_TYPE b, AsnLen &bytesDecoded, ENV_TYPE env);
  int			BEncPdu (BUF_TYPE b, AsnLen &bytesEncoded);
  int			BDecPdu (BUF_TYPE b, AsnLen &bytesDecoded);

  void		Print (ostream &os) const;
};


class DistributionPoint: public AsnType
{
public:
  DistributionPointName		*distributionPoint;
  ReasonFlags		*reasons;
  GeneralNames		*cRLIssuer;

			DistributionPoint();
			DistributionPoint (const DistributionPoint &);
			~DistributionPoint();
  AsnType		*Clone() const;

  DistributionPoint		&operator = (const DistributionPoint &);
  AsnLen		BEncContent (BUF_TYPE b);
  void			BDecContent (BUF_TYPE b, AsnTag tag, AsnLen elmtLen, AsnLen &bytesDecoded, ENV_TYPE env);

  AsnLen		BEnc (BUF_TYPE b);
  void			BDec (BUF_TYPE b, AsnLen &bytesDecoded, ENV_TYPE env);
  int			BEncPdu (BUF_TYPE b, AsnLen &bytesEncoded);
  int			BDecPdu (BUF_TYPE b, AsnLen &bytesDecoded);

  void		Print (ostream &os) const;
};


class CertificatePoliciesSyntax: public AsnType
{
protected:
  unsigned long int	count;
  struct AsnListElmt
  {
    AsnListElmt	*next;
    AsnListElmt	*prev;
    PolicyInformation	*elmt;
  }			*first, *curr, *last;

public:
			CertificatePoliciesSyntax() { count = 0; first = curr = last = NULL; }
			CertificatePoliciesSyntax (const CertificatePoliciesSyntax &);
			~CertificatePoliciesSyntax();
  AsnType		*Clone() const;

  CertificatePoliciesSyntax		&operator = (const CertificatePoliciesSyntax &);
  void		SetCurrElmt (unsigned long int index);
  unsigned long int	GetCurrElmtIndex();
  void		SetCurrToFirst() { curr = first; }
  void		SetCurrToLast()  { curr = last; }
  // reading member fcns
  int			Count() const	{ return count; }
  // NOTE: if your compiler complains about these NULLs, its definition of NULL is broken (and you better change it there!)
  PolicyInformation	*First() const	{ return count > 0 ? first->elmt : NULL; }
  PolicyInformation	*Last() const	{ return count > 0 ? last->elmt : NULL; }
  PolicyInformation	*Curr() const	{ return curr ? curr->elmt : NULL; }
  PolicyInformation	*Next() const	{ return curr && curr->next ? curr->next->elmt : NULL; }
  PolicyInformation	*Prev() const	{ return curr && curr->prev ? curr->prev->elmt : NULL; }

  // routines that move the curr elmt
  PolicyInformation	*GoNext() { if (curr) curr = curr->next; return Curr(); }
  PolicyInformation	*GoPrev() { if (curr) curr = curr->prev; return Curr(); }

  // write & alloc fcns - returns new elmt
  PolicyInformation	*Append();  // add elmt to end of list
  PolicyInformation	*Prepend(); // add elmt to beginning of list
  PolicyInformation	*InsertBefore(); //insert elmt before current elmt
  PolicyInformation	*InsertAfter(); //insert elmt after current elmt

  // write & alloc & copy - returns list after copying elmt
  CertificatePoliciesSyntax	&AppendCopy (PolicyInformation &elmt);  // add elmt to end of list
  CertificatePoliciesSyntax	&PrependCopy (PolicyInformation &elmt); // add elmt to beginning of list
  CertificatePoliciesSyntax	&InsertBeforeAndCopy (PolicyInformation &elmt); //insert elmt before current elmt
  CertificatePoliciesSyntax	&InsertAfterAndCopy (PolicyInformation &elmt); //insert elmt after current elmt

  // removing the current elmt from the list
  void		RemoveCurrFromList();

  // encode and decode routines    
  AsnLen		BEnc (BUF_TYPE b);
  void			BDec (BUF_TYPE b, AsnLen &bytesDecoded, ENV_TYPE env);
  AsnLen		BEncContent (BUF_TYPE b);
  void			BDecContent (BUF_TYPE b, AsnTag tag, AsnLen elmtLen, AsnLen &bytesDecoded, ENV_TYPE env);

  PDU_MEMBER_MACROS
  void		Print (ostream &os) const;
};


class GeneralSubtrees: public AsnType
{
protected:
  unsigned long int	count;
  struct AsnListElmt
  {
    AsnListElmt	*next;
    AsnListElmt	*prev;
    GeneralSubtree	*elmt;
  }			*first, *curr, *last;

public:
			GeneralSubtrees() { count = 0; first = curr = last = NULL; }
			GeneralSubtrees (const GeneralSubtrees &);
			~GeneralSubtrees();
  AsnType		*Clone() const;

  GeneralSubtrees		&operator = (const GeneralSubtrees &);
  void		SetCurrElmt (unsigned long int index);
  unsigned long int	GetCurrElmtIndex();
  void		SetCurrToFirst() { curr = first; }
  void		SetCurrToLast()  { curr = last; }
  // reading member fcns
  int			Count() const	{ return count; }
  // NOTE: if your compiler complains about these NULLs, its definition of NULL is broken (and you better change it there!)
  GeneralSubtree	*First() const	{ return count > 0 ? first->elmt : NULL; }
  GeneralSubtree	*Last() const	{ return count > 0 ? last->elmt : NULL; }
  GeneralSubtree	*Curr() const	{ return curr ? curr->elmt : NULL; }
  GeneralSubtree	*Next() const	{ return curr && curr->next ? curr->next->elmt : NULL; }
  GeneralSubtree	*Prev() const	{ return curr && curr->prev ? curr->prev->elmt : NULL; }

  // routines that move the curr elmt
  GeneralSubtree	*GoNext() { if (curr) curr = curr->next; return Curr(); }
  GeneralSubtree	*GoPrev() { if (curr) curr = curr->prev; return Curr(); }

  // write & alloc fcns - returns new elmt
  GeneralSubtree	*Append();  // add elmt to end of list
  GeneralSubtree	*Prepend(); // add elmt to beginning of list
  GeneralSubtree	*InsertBefore(); //insert elmt before current elmt
  GeneralSubtree	*InsertAfter(); //insert elmt after current elmt

  // write & alloc & copy - returns list after copying elmt
  GeneralSubtrees	&AppendCopy (GeneralSubtree &elmt);  // add elmt to end of list
  GeneralSubtrees	&PrependCopy (GeneralSubtree &elmt); // add elmt to beginning of list
  GeneralSubtrees	&InsertBeforeAndCopy (GeneralSubtree &elmt); //insert elmt before current elmt
  GeneralSubtrees	&InsertAfterAndCopy (GeneralSubtree &elmt); //insert elmt after current elmt

  // removing the current elmt from the list
  void		RemoveCurrFromList();

  // encode and decode routines    
  AsnLen		BEnc (BUF_TYPE b);
  void			BDec (BUF_TYPE b, AsnLen &bytesDecoded, ENV_TYPE env);
  AsnLen		BEncContent (BUF_TYPE b);
  void			BDecContent (BUF_TYPE b, AsnTag tag, AsnLen elmtLen, AsnLen &bytesDecoded, ENV_TYPE env);

  PDU_MEMBER_MACROS
  void		Print (ostream &os) const;
};


class AuthorityKeyIdentifier: public AsnType
{
public:
  KeyIdentifier		*keyIdentifier;
  GeneralNames		*authorityCertIssuer;
  CertificateSerialNumber		*authorityCertSerialNumber;

			AuthorityKeyIdentifier();
			AuthorityKeyIdentifier (const AuthorityKeyIdentifier &);
			~AuthorityKeyIdentifier();
  AsnType		*Clone() const;

  AuthorityKeyIdentifier		&operator = (const AuthorityKeyIdentifier &);
  AsnLen		BEncContent (BUF_TYPE b);
  void			BDecContent (BUF_TYPE b, AsnTag tag, AsnLen elmtLen, AsnLen &bytesDecoded, ENV_TYPE env);

  AsnLen		BEnc (BUF_TYPE b);
  void			BDec (BUF_TYPE b, AsnLen &bytesDecoded, ENV_TYPE env);
  int			BEncPdu (BUF_TYPE b, AsnLen &bytesEncoded);
  int			BDecPdu (BUF_TYPE b, AsnLen &bytesDecoded);

  void		Print (ostream &os) const;
};


/* KeyIdentifier */
typedef KeyIdentifier SubjectKeyIdentifier;

class PrivateKeyUsagePeriod: public AsnType
{
public:
  GeneralizedTime		*notBefore;
  GeneralizedTime		*notAfter;

			PrivateKeyUsagePeriod();
			PrivateKeyUsagePeriod (const PrivateKeyUsagePeriod &);
			~PrivateKeyUsagePeriod();
  AsnType		*Clone() const;

  PrivateKeyUsagePeriod		&operator = (const PrivateKeyUsagePeriod &);
  AsnLen		BEncContent (BUF_TYPE b);
  void			BDecContent (BUF_TYPE b, AsnTag tag, AsnLen elmtLen, AsnLen &bytesDecoded, ENV_TYPE env);

  AsnLen		BEnc (BUF_TYPE b);
  void			BDec (BUF_TYPE b, AsnLen &bytesDecoded, ENV_TYPE env);
  int			BEncPdu (BUF_TYPE b, AsnLen &bytesEncoded);
  int			BDecPdu (BUF_TYPE b, AsnLen &bytesDecoded);

  void		Print (ostream &os) const;
};


class PolicyMappingsSyntax: public AsnType
{
protected:
  unsigned long int	count;
  struct AsnListElmt
  {
    AsnListElmt	*next;
    AsnListElmt	*prev;
    PolicyMappingsSyntaxSeq	*elmt;
  }			*first, *curr, *last;

public:
			PolicyMappingsSyntax() { count = 0; first = curr = last = NULL; }
			PolicyMappingsSyntax (const PolicyMappingsSyntax &);
			~PolicyMappingsSyntax();
  AsnType		*Clone() const;

  PolicyMappingsSyntax		&operator = (const PolicyMappingsSyntax &);
  void		SetCurrElmt (unsigned long int index);
  unsigned long int	GetCurrElmtIndex();
  void		SetCurrToFirst() { curr = first; }
  void		SetCurrToLast()  { curr = last; }
  // reading member fcns
  int			Count() const	{ return count; }
  // NOTE: if your compiler complains about these NULLs, its definition of NULL is broken (and you better change it there!)
  PolicyMappingsSyntaxSeq	*First() const	{ return count > 0 ? first->elmt : NULL; }
  PolicyMappingsSyntaxSeq	*Last() const	{ return count > 0 ? last->elmt : NULL; }
  PolicyMappingsSyntaxSeq	*Curr() const	{ return curr ? curr->elmt : NULL; }
  PolicyMappingsSyntaxSeq	*Next() const	{ return curr && curr->next ? curr->next->elmt : NULL; }
  PolicyMappingsSyntaxSeq	*Prev() const	{ return curr && curr->prev ? curr->prev->elmt : NULL; }

  // routines that move the curr elmt
  PolicyMappingsSyntaxSeq	*GoNext() { if (curr) curr = curr->next; return Curr(); }
  PolicyMappingsSyntaxSeq	*GoPrev() { if (curr) curr = curr->prev; return Curr(); }

  // write & alloc fcns - returns new elmt
  PolicyMappingsSyntaxSeq	*Append();  // add elmt to end of list
  PolicyMappingsSyntaxSeq	*Prepend(); // add elmt to beginning of list
  PolicyMappingsSyntaxSeq	*InsertBefore(); //insert elmt before current elmt
  PolicyMappingsSyntaxSeq	*InsertAfter(); //insert elmt after current elmt

  // write & alloc & copy - returns list after copying elmt
  PolicyMappingsSyntax	&AppendCopy (PolicyMappingsSyntaxSeq &elmt);  // add elmt to end of list
  PolicyMappingsSyntax	&PrependCopy (PolicyMappingsSyntaxSeq &elmt); // add elmt to beginning of list
  PolicyMappingsSyntax	&InsertBeforeAndCopy (PolicyMappingsSyntaxSeq &elmt); //insert elmt before current elmt
  PolicyMappingsSyntax	&InsertAfterAndCopy (PolicyMappingsSyntaxSeq &elmt); //insert elmt after current elmt

  // removing the current elmt from the list
  void		RemoveCurrFromList();

  // encode and decode routines    
  AsnLen		BEnc (BUF_TYPE b);
  void			BDec (BUF_TYPE b, AsnLen &bytesDecoded, ENV_TYPE env);
  AsnLen		BEncContent (BUF_TYPE b);
  void			BDecContent (BUF_TYPE b, AsnTag tag, AsnLen elmtLen, AsnLen &bytesDecoded, ENV_TYPE env);

  PDU_MEMBER_MACROS
  void		Print (ostream &os) const;
};


class SupportedAlgorithm: public AsnType
{
public:
  AlgorithmIdentifier		*algorithmIdentifier;
  KeyUsage		*intendedUsage;
  CertificatePoliciesSyntax		*intendedCertificatePolicies;

			SupportedAlgorithm();
			SupportedAlgorithm (const SupportedAlgorithm &);
			~SupportedAlgorithm();
  AsnType		*Clone() const;

  SupportedAlgorithm		&operator = (const SupportedAlgorithm &);
  AsnLen		BEncContent (BUF_TYPE b);
  void			BDecContent (BUF_TYPE b, AsnTag tag, AsnLen elmtLen, AsnLen &bytesDecoded, ENV_TYPE env);

  AsnLen		BEnc (BUF_TYPE b);
  void			BDec (BUF_TYPE b, AsnLen &bytesDecoded, ENV_TYPE env);
  int			BEncPdu (BUF_TYPE b, AsnLen &bytesEncoded);
  int			BDecPdu (BUF_TYPE b, AsnLen &bytesDecoded);

  void		Print (ostream &os) const;
};


/* GeneralNames */
typedef GeneralNames SubjectName;

/* GeneralNames */
typedef GeneralNames IssuerAltName;

/* AttributesSyntax */
typedef AttributesSyntax SubjectDirectoryAttributes;

class BasicConstraintsSyntax: public AsnType
{
public:
  AsnBool		*cA;
  AsnInt		*pathLenConstraint;

			BasicConstraintsSyntax();
			BasicConstraintsSyntax (const BasicConstraintsSyntax &);
			~BasicConstraintsSyntax();
  AsnType		*Clone() const;

  BasicConstraintsSyntax		&operator = (const BasicConstraintsSyntax &);
  AsnLen		BEncContent (BUF_TYPE b);
  void			BDecContent (BUF_TYPE b, AsnTag tag, AsnLen elmtLen, AsnLen &bytesDecoded, ENV_TYPE env);

  AsnLen		BEnc (BUF_TYPE b);
  void			BDec (BUF_TYPE b, AsnLen &bytesDecoded, ENV_TYPE env);
  int			BEncPdu (BUF_TYPE b, AsnLen &bytesEncoded);
  int			BDecPdu (BUF_TYPE b, AsnLen &bytesDecoded);

  void		Print (ostream &os) const;
};


class NameConstraintsSyntax: public AsnType
{
public:
  GeneralSubtrees		*permittedSubtrees;
  GeneralSubtrees		*excludedSubtrees;

			NameConstraintsSyntax();
			NameConstraintsSyntax (const NameConstraintsSyntax &);
			~NameConstraintsSyntax();
  AsnType		*Clone() const;

  NameConstraintsSyntax		&operator = (const NameConstraintsSyntax &);
  AsnLen		BEncContent (BUF_TYPE b);
  void			BDecContent (BUF_TYPE b, AsnTag tag, AsnLen elmtLen, AsnLen &bytesDecoded, ENV_TYPE env);

  AsnLen		BEnc (BUF_TYPE b);
  void			BDec (BUF_TYPE b, AsnLen &bytesDecoded, ENV_TYPE env);
  int			BEncPdu (BUF_TYPE b, AsnLen &bytesEncoded);
  int			BDecPdu (BUF_TYPE b, AsnLen &bytesDecoded);

  void		Print (ostream &os) const;
};


class PolicyConstraintsSyntax: public AsnType
{
public:
  SkipCerts		*requireExplicitPolicy;
  SkipCerts		*inhibitPolicyMapping;

			PolicyConstraintsSyntax();
			PolicyConstraintsSyntax (const PolicyConstraintsSyntax &);
			~PolicyConstraintsSyntax();
  AsnType		*Clone() const;

  PolicyConstraintsSyntax		&operator = (const PolicyConstraintsSyntax &);
  AsnLen		BEncContent (BUF_TYPE b);
  void			BDecContent (BUF_TYPE b, AsnTag tag, AsnLen elmtLen, AsnLen &bytesDecoded, ENV_TYPE env);

  AsnLen		BEnc (BUF_TYPE b);
  void			BDec (BUF_TYPE b, AsnLen &bytesDecoded, ENV_TYPE env);
  int			BEncPdu (BUF_TYPE b, AsnLen &bytesEncoded);
  int			BDecPdu (BUF_TYPE b, AsnLen &bytesDecoded);

  void		Print (ostream &os) const;
};


class CertPolicySet: public AsnType
{
protected:
  unsigned long int	count;
  struct AsnListElmt
  {
    AsnListElmt	*next;
    AsnListElmt	*prev;
    CertPolicyId	*elmt;
  }			*first, *curr, *last;

public:
			CertPolicySet() { count = 0; first = curr = last = NULL; }
			CertPolicySet (const CertPolicySet &);
			~CertPolicySet();
  AsnType		*Clone() const;

  CertPolicySet		&operator = (const CertPolicySet &);
  void		SetCurrElmt (unsigned long int index);
  unsigned long int	GetCurrElmtIndex();
  void		SetCurrToFirst() { curr = first; }
  void		SetCurrToLast()  { curr = last; }
  // reading member fcns
  int			Count() const	{ return count; }
  // NOTE: if your compiler complains about these NULLs, its definition of NULL is broken (and you better change it there!)
  CertPolicyId	*First() const	{ return count > 0 ? first->elmt : NULL; }
  CertPolicyId	*Last() const	{ return count > 0 ? last->elmt : NULL; }
  CertPolicyId	*Curr() const	{ return curr ? curr->elmt : NULL; }
  CertPolicyId	*Next() const	{ return curr && curr->next ? curr->next->elmt : NULL; }
  CertPolicyId	*Prev() const	{ return curr && curr->prev ? curr->prev->elmt : NULL; }

  // routines that move the curr elmt
  CertPolicyId	*GoNext() { if (curr) curr = curr->next; return Curr(); }
  CertPolicyId	*GoPrev() { if (curr) curr = curr->prev; return Curr(); }

  // write & alloc fcns - returns new elmt
  CertPolicyId	*Append();  // add elmt to end of list
  CertPolicyId	*Prepend(); // add elmt to beginning of list
  CertPolicyId	*InsertBefore(); //insert elmt before current elmt
  CertPolicyId	*InsertAfter(); //insert elmt after current elmt

  // write & alloc & copy - returns list after copying elmt
  CertPolicySet	&AppendCopy (CertPolicyId &elmt);  // add elmt to end of list
  CertPolicySet	&PrependCopy (CertPolicyId &elmt); // add elmt to beginning of list
  CertPolicySet	&InsertBeforeAndCopy (CertPolicyId &elmt); //insert elmt before current elmt
  CertPolicySet	&InsertAfterAndCopy (CertPolicyId &elmt); //insert elmt after current elmt

  // removing the current elmt from the list
  void		RemoveCurrFromList();

  // encode and decode routines    
  AsnLen		BEnc (BUF_TYPE b);
  void			BDec (BUF_TYPE b, AsnLen &bytesDecoded, ENV_TYPE env);
  AsnLen		BEncContent (BUF_TYPE b);
  void			BDecContent (BUF_TYPE b, AsnTag tag, AsnLen elmtLen, AsnLen &bytesDecoded, ENV_TYPE env);

  PDU_MEMBER_MACROS
  void		Print (ostream &os) const;
};


/* GeneralizedTime */
typedef GeneralizedTime InvalidityDate;

class CRLDistPointsSyntax: public AsnType
{
protected:
  unsigned long int	count;
  struct AsnListElmt
  {
    AsnListElmt	*next;
    AsnListElmt	*prev;
    DistributionPoint	*elmt;
  }			*first, *curr, *last;

public:
			CRLDistPointsSyntax() { count = 0; first = curr = last = NULL; }
			CRLDistPointsSyntax (const CRLDistPointsSyntax &);
			~CRLDistPointsSyntax();
  AsnType		*Clone() const;

  CRLDistPointsSyntax		&operator = (const CRLDistPointsSyntax &);
  void		SetCurrElmt (unsigned long int index);
  unsigned long int	GetCurrElmtIndex();
  void		SetCurrToFirst() { curr = first; }
  void		SetCurrToLast()  { curr = last; }
  // reading member fcns
  int			Count() const	{ return count; }
  // NOTE: if your compiler complains about these NULLs, its definition of NULL is broken (and you better change it there!)
  DistributionPoint	*First() const	{ return count > 0 ? first->elmt : NULL; }
  DistributionPoint	*Last() const	{ return count > 0 ? last->elmt : NULL; }
  DistributionPoint	*Curr() const	{ return curr ? curr->elmt : NULL; }
  DistributionPoint	*Next() const	{ return curr && curr->next ? curr->next->elmt : NULL; }
  DistributionPoint	*Prev() const	{ return curr && curr->prev ? curr->prev->elmt : NULL; }

  // routines that move the curr elmt
  DistributionPoint	*GoNext() { if (curr) curr = curr->next; return Curr(); }
  DistributionPoint	*GoPrev() { if (curr) curr = curr->prev; return Curr(); }

  // write & alloc fcns - returns new elmt
  DistributionPoint	*Append();  // add elmt to end of list
  DistributionPoint	*Prepend(); // add elmt to beginning of list
  DistributionPoint	*InsertBefore(); //insert elmt before current elmt
  DistributionPoint	*InsertAfter(); //insert elmt after current elmt

  // write & alloc & copy - returns list after copying elmt
  CRLDistPointsSyntax	&AppendCopy (DistributionPoint &elmt);  // add elmt to end of list
  CRLDistPointsSyntax	&PrependCopy (DistributionPoint &elmt); // add elmt to beginning of list
  CRLDistPointsSyntax	&InsertBeforeAndCopy (DistributionPoint &elmt); //insert elmt before current elmt
  CRLDistPointsSyntax	&InsertAfterAndCopy (DistributionPoint &elmt); //insert elmt after current elmt

  // removing the current elmt from the list
  void		RemoveCurrFromList();

  // encode and decode routines    
  AsnLen		BEnc (BUF_TYPE b);
  void			BDec (BUF_TYPE b, AsnLen &bytesDecoded, ENV_TYPE env);
  AsnLen		BEncContent (BUF_TYPE b);
  void			BDecContent (BUF_TYPE b, AsnTag tag, AsnLen elmtLen, AsnLen &bytesDecoded, ENV_TYPE env);

  PDU_MEMBER_MACROS
  void		Print (ostream &os) const;
};


class IssuingDistPointSyntax: public AsnType
{
public:
  DistributionPointName		*distributionPoint;
  AsnBool		*onlyContainsUserCerts;
  AsnBool		*onlyContainsCACerts;
  ReasonFlags		*onlySomeReasons;
  AsnBool		*indirectCRL;

			IssuingDistPointSyntax();
			IssuingDistPointSyntax (const IssuingDistPointSyntax &);
			~IssuingDistPointSyntax();
  AsnType		*Clone() const;

  IssuingDistPointSyntax		&operator = (const IssuingDistPointSyntax &);
  AsnLen		BEncContent (BUF_TYPE b);
  void			BDecContent (BUF_TYPE b, AsnTag tag, AsnLen elmtLen, AsnLen &bytesDecoded, ENV_TYPE env);

  AsnLen		BEnc (BUF_TYPE b);
  void			BDec (BUF_TYPE b, AsnLen &bytesDecoded, ENV_TYPE env);
  int			BEncPdu (BUF_TYPE b, AsnLen &bytesEncoded);
  int			BDecPdu (BUF_TYPE b, AsnLen &bytesDecoded);

  void		Print (ostream &os) const;
};


/* GeneralNames */
typedef GeneralNames CertificateIssuer;

/* CRLNumber */
typedef CRLNumber BaseCRLNumber;

/* CertificateList */
typedef CertificateList DeltaRevocationList;

//------------------------------------------------------------------------------
// externs for value defs

extern const AsnOid id_at_supportedAlgorithms;
extern const AsnOid id_at_deltaRevocationList;
extern const AsnOid id_ce_subjectDirectoryAttributes;
extern const AsnOid id_ce_subjectKeyIdentifier;
extern const AsnOid id_ce_keyUsage;
extern const AsnOid id_ce_privateKeyUsagePeriod;
extern const AsnOid id_ce_subjectAltName;
extern const AsnOid id_ce_issuerAltName;
extern const AsnOid id_ce_basicConstraints;
extern const AsnOid id_ce_cRLNumber;
extern const AsnOid id_ce_reasonCode;
extern const AsnOid id_ce_instructionCode;
extern const AsnOid id_ce_invalidityDate;
extern const AsnOid id_ce_deltaCRLIndicator;
extern const AsnOid id_ce_issuingDistributionPoint;
extern const AsnOid id_ce_certificateIssuer;
extern const AsnOid id_ce_nameConstraints;
extern const AsnOid id_ce_cRLDistributionPoints;
extern const AsnOid id_ce_certificatePolicies;
extern const AsnOid id_ce_policyMappings;
extern const AsnOid id_ce_authorityKeyIdentifier;
extern const AsnOid id_ce_policyConstraints;
extern const AsnOid id_ce_extKeyUsage;
extern const AsnOid id_mr_certificateExactMatch;
extern const AsnOid id_mr_certificateMatch;
extern const AsnOid id_mr_certificatePairExactMatch;
extern const AsnOid id_mr_certificatePairMatch;
extern const AsnOid id_mr_certificateListExactMatch;
extern const AsnOid id_mr_certificateListMatch;
extern const AsnOid id_mr_algorithmIdentifierMatch;
//------------------------------------------------------------------------------

#endif /* conditional include of sm_x509ce.h */
