#ifndef NO_SCCS_ID
static char SccsId[ ] = "@(#) sm_CsmDn.cpp 1.6 2/18/98 15:43:59"; 
#endif
#include "sm_api.h"

// The following CSM_DN member functions are defined here:
// CONSTRUCTORS
// GetDNString()
// SetEncodedDN(CSM_Buffer &EncCSMB)
// Decode()

// CONSTRUCTORS
// use this constructor to create a complete empty DN structure
CSM_DN::CSM_DN() 
{
   m_pszDN = NULL; 
   m_pEncodedDN = NULL; 
   m_pSNACCName = NULL;
}

// use this constructor to make a copy of the provided DN structure
// and put it into this structure
CSM_DN::CSM_DN(CSM_Buffer *PCSMB) 
{
   m_pszDN = NULL;
   m_pEncodedDN = NULL; 
   m_pSNACCName = NULL;
   SetEncodedDN(*PCSMB); 
}

// use this constructor to make a new m_pSNACCName SNACC structure
CSM_DN::CSM_DN(Name &issuer) 
{
   m_pszDN = NULL; 
   m_pEncodedDN = NULL; 
   m_pSNACCName = new Name; 
   *m_pSNACCName = issuer;
}

CSM_DN & CSM_DN::operator = (Name &SNACCDN) 
{
   if (m_pSNACCName != NULL)
      delete m_pSNACCName;
   m_pSNACCName = new Name(SNACCDN);

   if (m_pEncodedDN != NULL)
   {
      delete m_pEncodedDN;
      m_pEncodedDN = NULL;
   }
   return *this;
}

CSM_DN::operator Name* ()
{
   if (m_pEncodedDN != NULL)
   {
      if (m_pSNACCName == NULL)
         m_pSNACCName = new Name;
      DECODE_BUF(m_pSNACCName, m_pEncodedDN);
   }
   return(m_pSNACCName);
}

// GetDNString member function
char * CSM_DN::GetDNString()
{
   RelativeDistinguishedName *pTmpRDN;
   AttributeTypeAndDistinguishedValue *pTmpRDN2;
   CSM_Buffer *pTmpBuf;
   PrintableString tmpPS;

   m_pszDN = (char *)calloc(1,1024);

   m_pSNACCName->rDNSequence->SetCurrToFirst();
   for (pTmpRDN = m_pSNACCName->rDNSequence->First(); pTmpRDN != NULL;
        pTmpRDN = m_pSNACCName->rDNSequence->GoNext())
   {
      pTmpRDN->SetCurrToFirst();
      for (pTmpRDN2 = pTmpRDN->First(); pTmpRDN2 != NULL;
           pTmpRDN2 = pTmpRDN->GoNext())
      {
          if (pTmpRDN2->type == id_at_countryName)
          {
             strcat(m_pszDN, "C=");

             SM_EXTRACT_ANYBUF(pTmpBuf, &(pTmpRDN2->value));
             DECODE_BUF(&tmpPS, pTmpBuf);
             strncat(m_pszDN, (const char *)tmpPS, tmpPS.Len());
             strcat(m_pszDN, "@");
          }
          else if (pTmpRDN2->type == id_at_commonName)
          {
             strcat(m_pszDN, "CN=");

             SM_EXTRACT_ANYBUF(pTmpBuf, &(pTmpRDN2->value));
             DECODE_BUF(&tmpPS, pTmpBuf);
             strncat(m_pszDN, (const char *)tmpPS, tmpPS.Len());
             strcat(m_pszDN, "@");
          }
          else if (pTmpRDN2->type == id_at_surname)
          {
             strcat(m_pszDN, "SN=");

             SM_EXTRACT_ANYBUF(pTmpBuf, &(pTmpRDN2->value));
             DECODE_BUF(&tmpPS, pTmpBuf);
             strncat(m_pszDN, (const char *)tmpPS, tmpPS.Len());
             strcat(m_pszDN, "@");
          }
          else if (pTmpRDN2->type == id_at_localityName)
          {
             strcat(m_pszDN, "L=");

             SM_EXTRACT_ANYBUF(pTmpBuf, &(pTmpRDN2->value));
             DECODE_BUF(&tmpPS, pTmpBuf);
             strncat(m_pszDN, (const char *)tmpPS, tmpPS.Len());
             strcat(m_pszDN, "@");
          }
          else if (pTmpRDN2->type == id_at_organizationName)
          {
             strcat(m_pszDN, "O=");

             SM_EXTRACT_ANYBUF(pTmpBuf, &(pTmpRDN2->value));
             DECODE_BUF(&tmpPS, pTmpBuf);
             strncat(m_pszDN, (const char *)tmpPS, tmpPS.Len());
             strcat(m_pszDN, "@");
          }
          else if (pTmpRDN2->type == id_at_organizationalUnitName)
          {
             strcat(m_pszDN, "OU=");

             SM_EXTRACT_ANYBUF(pTmpBuf, &(pTmpRDN2->value));
             DECODE_BUF(&tmpPS, pTmpBuf);
             strncat(m_pszDN, (const char *)tmpPS, tmpPS.Len());
             strcat(m_pszDN, "@");
          }
          else
          {
             strcat(m_pszDN, "UNKNOWN=");
             SM_EXTRACT_ANYBUF(pTmpBuf, &(pTmpRDN2->value));
             DECODE_BUF(&tmpPS, pTmpBuf);
             strncat(m_pszDN, (const char *)tmpPS, tmpPS.Len());
             strcat(m_pszDN, "@");
          }
      }

   }

   if ((strlen(m_pszDN) == 0))
   {
      free(m_pszDN);
      m_pszDN = NULL;
   }

   //remove extra character at end of string
   m_pszDN[strlen(m_pszDN)-1] = NULL;

   return(m_pszDN);

}


// SetEncodedDN member function
void CSM_DN::SetEncodedDN(CSM_Buffer &EncCSMB)
{
   m_pEncodedDN = new CSM_Buffer(EncCSMB);
}

// GetEncodedDN member function
CSM_Buffer * CSM_DN::GetEncodedDN() 
{
   if ((m_pEncodedDN == NULL) && (m_pSNACCName != NULL))
      ENCODE_BUF(m_pSNACCName, m_pEncodedDN);
   return m_pEncodedDN;
}


// Decode member function
void CSM_DN::Decode()
{
   if (m_pEncodedDN != NULL) 
   {
      if (m_pSNACCName == NULL)
         m_pSNACCName = new Name;
      DECODE_BUF(m_pSNACCName, m_pEncodedDN);
   }
}


