#ifndef NO_SCCS_ID
static char SccsId[ ] = "@(#) sm_Autohi.cpp 1.5 3/26/98 11:53:58"; 
#endif

/***
  sm_AutoAsn.c
  This main program initiates a series of tests for automatically testing the
  S/MIME ASN.1 enc/decs.  It allows multiple execution of any series of test
  cases through the use of a configuration file.  All tests are executed in 
  order and errors are reported.
***/

#include <stdio.h>
#include <stdlib.h>
#include "sm_util.h"

MAB_AB_def *p_GAddressBook;

long SM_CfgLogins(char *fileName, CSMIME *pCsmime);

int main(int argc, char *argv[])
{
   long status=0;
   long verify_flag=0;     /** TBD;flag to indicate that the produced results
                                should be checked with previous AND/OR actual
                                input. **/
   long output_flag=0;     /* 0 = pass/fail, 1=detailed output, -1=no output */
   int sectionNotFound=0;
   FILE *fp;
   char buf[80];
   char lpszConfigSection[80];
   long lNumRuns = 0;
   long lCurrentRun;
   CSMIME *pCsmime=new CSMIME;

   if (argc < 2)
   {
      printf("usage: %s testConfigFile.cfg.\n", argv[0]);
      exit(-1);
   }
   if ((fp=fopen(argv[1], "r")) != NULL)
   {
      SME_SETUP("SM_Autohi_MAIN");
      /** First, determine the section to be tested and position the 
          file pointer. **/
      while (status == 0 && !sectionNotFound && fgets(buf, 80, fp) != NULL)
      {                  /** only perform "fgets()" if "sectionNotFound".**/
         if (buf[strlen(buf)-1] == '\n')
               buf[strlen(buf)-1] = '\0';        /** terminate, no return. **/
         if (buf[0] != '#')      /** comment line **/
         {
            if (strncmp(buf, "verify=", strlen("verify=")) == 0)
            {
               verify_flag = atoi(&buf[strlen("verify=")]);
            }
            else if (strncmp(buf, "output=", strlen("output=")) == 0)
            {
               output_flag = atoi(&buf[strlen("output=")]);
            }
            else if (strncmp(buf, "number_of_runs=", 
                  strlen("number_of_runs=")) == 0)
            {
               lNumRuns = atol(&buf[strlen("number_of_runs=")]) - 1;
            }
            else if (strncmp(buf, "Logins=", 
                  strlen("Logins=")) == 0)
            {
               SME(status = SM_CfgLogins(&buf[strlen("Logins=")], pCsmime));
            }
            else if (strncmp(buf, "AddressBook=", 
                  strlen("AddressBook=")) == 0)
            {
               SME(p_GAddressBook = new MAB_AB_def(&buf[strlen("AddressBook=")]));
            }
            else if (strncmp(buf, "hi_tests=", strlen("hi_tests="))==0)
            {
               /** position the file pointer to the specified section. **/
               lpszConfigSection[0] = '\0';
               sscanf(&buf[strlen("hi_tests=")],"%s",lpszConfigSection);
               if (lpszConfigSection[strlen(lpszConfigSection)-1] == '\n')
                  lpszConfigSection[strlen(lpszConfigSection)-1] = '\0';
               sectionNotFound = 1;
            }
         }        
      }
      fclose(fp);

      /** Next, read each entry in order and execute. **/
      lCurrentRun = 0;
      while (sectionNotFound && status == 0 && lCurrentRun <= lNumRuns)
      {
            if (lNumRuns > 1)
               printf("DOING %ld RUNS######################\n",
                        lNumRuns + 1);
            SME(status = SM_AutoHiFunction(argv[1], pCsmime, &lpszConfigSection[0], 
                output_flag, verify_flag));
            if (lNumRuns > 1)
               printf(" run %ld", lCurrentRun);
            ++lCurrentRun;
      } /* go through all number of runs */
      SME_FINISH_CATCH_APP
   }
   else
   {
      printf("auto_asn: could not open testConfig File=%s.\n", argv[1]);
      status = -1;
   }

   delete pCsmime;

   return((int)status);
}



/*** EOF SM_auto_asn.c ***/
