#ifndef NO_SCCS_ID
static char SccsId[ ] = "@(#) sm_CfgCheckContentInfo.cpp 1.2 3/18/98 10:01:26"; 
#endif

// sm_CfgCheckContentInfo.cpp
// This test routine supports the test of the SNACC ContentInfo
// SMIME data type encoding/decoding.
//

#include "sm_api.h"

SM_RET_VAL SM_CfgCheckContentInfo(char *lpszContentInfoFile, 
    char *lpszContentFile, 
    char *lpszContentType,  // IN, ONLY valid for Encode.
    bool bEncodeFlag)
{
     SM_RET_VAL status=0;
     CSM_ContentInfoMsg *pCI=NULL;
     CSM_OID tOID;
     CSM_Buffer *pContent=new CSM_Buffer(lpszContentFile);

     SME_SETUP("SM_CfgCheckContentInfo");

     if (strcmp(lpszContentType, "SignedData") == 0)
        tOID = id_signedData;
     else if (strcmp(lpszContentType, "EnvelopedData") == 0)
        tOID = id_envelopedData;
     else if (strcmp(lpszContentType, "Data") == 0)
        tOID = id_data;
     else               // attempt to interpret as an OID String.
         if (strlen(lpszContentType))
           SME(tOID = CSM_OID(lpszContentType));

     if (bEncodeFlag)
     {
        pCI = new CSM_ContentInfoMsg;
        SME(pCI->SetEncapContent(CSM_Content(pContent, tOID)));
        SME((pCI->GetEncodedCI())->ConvertMemoryToFile(lpszContentInfoFile));
     }
     else               // decode ContentInfo from "lpszContentInfoFile"
     {
        pCI = new CSM_ContentInfoMsg;
        SME(pCI->SetEncodedCI(CSM_Buffer(lpszContentInfoFile)));
        if (pCI->IsSignedData())
            printf("SM_CfgCheckContentInfo: SignedData content.\n");
        else if (pCI->IsEnvelopedData())
            printf("SM_CfgCheckContentInfo: EnvelopedData content.\n");
        else if (pCI->IsData())
            printf("SM_CfgCheckContentInfo: Data content.\n");
        else
            printf("SM_CfgCheckContentInfo: OID=%s content\n",
                pCI->GetEncapContent()->m_contentType.GetChar()); 
        SME(pCI->GetEncapContent()->m_content.
            ConvertMemoryToFile(lpszContentFile));
     }

     delete pContent;
     if (pCI)
         delete pCI;

     SME_FINISH
     SME_CATCH_SETUP
        // local cleanup logic
        delete pContent;
        if (pCI)
            delete pCI;
     SME_CATCH_FINISH

    return(status);
}

// EOF sm_CfgCheckContentInfo.cpp
