#ifndef NO_SCCS_ID
static char SccsId[ ] = "@(#) sm_CfgCheckDecrypt.cpp 1.2 3/20/98 17:29:30"; 
#endif

//////////////////////////////////////////////////////////////////////////
// This source file contains the check test routines for Decrypt classes

#include <stdio.h>
#include "sm_util.h"

SM_RET_VAL SM_CfgCheckDecrypt(char *pszCfgFile, CSMIME *pCSMIME,
                              long output_flag, long verify_flag)
{
   char *pszOrigCfgFile = SM_SetCfgFn(pszCfgFile);
   SM_RET_VAL lRet = SM_NO_ERROR;
   CSM_DecryptMsg smDecryptMsg;
   KwValue kwDecryptedContent;

   SME_SETUP("SM_CfgCheckDecrypt");

   if (pCSMIME == NULL)
      SME_THROW(SM_MISSING_PARAM, NULL, NULL);

   // fill the CSM_DecryptMsg class
   if (output_flag == 1)
      printf("SM_CfgCheckDecrypt: filling and preproc-ing CSM_DecryptMsg\n");
   SME(SM_CfgFillDecryptMsg(pCSMIME, &smDecryptMsg, "EnvelopedDataTest"));

   // call CSM_DecryptMsg::Decrypt to do the real work
   if (output_flag == 1)
      printf("SM_CfgCheckDecrypt: calling Decrypt\n");
   SME(smDecryptMsg.Decrypt(pCSMIME));
   if (output_flag != -1)
      printf("SM_CfgCheckDecrypt: returned SM_NO_ERROR!!!\n");

   // convert the result to file (TBD, done right?)
   if ((lRet = SM_GetKwValue("DecryptedContentFN", kwDecryptedContent,
            "EnvelopedDataTest")) != SM_NO_ERROR)
      SME_THROW(lRet, "DecryptedContentFN kw missing", NULL);
   CSM_Content *pContent = smDecryptMsg.GetEncapContent();
   SME(pContent->m_content.ConvertMemoryToFile(kwDecryptedContent));
   if (output_flag == 1)
   {
      printf("SM_CfgCheckDecrypt: converted result to file %s\n", 
            kwDecryptedContent);
      printf("SM_CfgCheckDecrypt: content oid: %s\n", 
            pContent->m_contentType.GetChar());
   }

   if (output_flag == 1)
      printf("SM_CfgCheckDecrypt: warning, verify not implemented yet\n");

   SM_SetCfgFn(pszOrigCfgFile); // restore orig config file

   SME_FINISH
   SME_CATCH_SETUP
      // catch/cleanup logic as necessary
      // result original cfg file?
   SME_CATCH_FINISH

   return lRet;
}

// EOF sm_CfgCheckDecrypt.cpp
