#ifndef NO_SCCS_ID
static char SccsId[ ] = "@(#) sm_CfgCheckVerify.cpp 1.2 2/17/98 14:05:24"; 
#endif

/* sm_CfgCheckVerify.cpp */
#include <stdio.h>
#include "sm_util.h"


SM_RET_VAL SM_CfgCheckVerify(char *pszCfgFile, CSMIME *pCsmime,
      long output_flag, long verify_flag)
{
   //KwValue kwValue;
   KwValue fn;
   char *pszOrigCfgFile = SM_SetCfgFn(pszCfgFile); /* set config file */
   SM_RET_VAL ret = SM_NO_ERROR;
   CSM_ErrorBuf error;
   CSM_VerifyMsg smVerifyMsg;


    SME_SETUP("sm_CfgCheckVerify");
   /* fill a SM_Signed_data */
   if (output_flag == 1)
      printf("sm_CfgCheckVerify: filling...\n");
   //if ((ret = SM_GetKwValue("SignDataSection", kwValue, "EncSignedDataTest")) == 
   //         SM_NO_ERROR)
   {
      if ((ret = SM_GetKwValue("EncodedSignDataFN", fn, "VerifyTest")) ==
            SM_NO_ERROR)
      {
            /* ASN.1 encode the receipt */
            if (output_flag == 1)
               printf("sm_CfgCheckVerify: checking...\n");
            pCsmime->UseAll();
            if ((ret = smVerifyMsg.Verify(pCsmime, CSM_Buffer(fn))) == SM_NO_ERROR)
            {
               if (output_flag == 1)
               {
                  //printf("sm_CfgCheckVerify: prt C structure...\n");
                  //SM_PrtSignData(&smSignMsg);
                  //printf("\nsm_CfgCheckVerify:  printing asn.1...\n");
                  //SM_PrtHex(Result.str, Result.lgth);
                  printf("\n");
                  printf("sm_CfgCheckVerify: Successful Verification of signature.\n");
               }
               if (output_flag != -1)
                  printf("\nSM_CheckSignedData returned SM_NO_ERROR\n");
            }
            else
            {
               printf("sm_CfgCheckVerify: Sign returned %ld\n",
                     ret);
               SME_THROW(22, "Sign() failed.", NULL);
            }
      }
      else
         printf("sm_CfgCheckVerify: missing EncodedSignDataFN kw\n");
   }
   SM_SetCfgFn(pszOrigCfgFile);

   SME_FINISH_CATCH

   return ret;
}

#ifdef BOB
SM_RET_VAL SM_CfgCheckDecSignData(char *pszCfgFile, 
      short output_flag, short verify_flag)
{
   KwValue fn;
   char *pszOrigCfgFile = SM_SetCfgFn(pszCfgFile); /* set config file */
   SM_RET_VAL ret = SM_NO_ERROR;
   SM_Signed_data *pSignData = NULL;
   SM_Str_struct result;
   SM_Buf_file bf;
   SM_ErrorBuf error;

   memset(&error, 0, sizeof(SM_ErrorBuf));

   if ((ret = SM_GetKwValue("EncodedSignDataFN", fn, "DecSignDataTest")) == 
            SM_NO_ERROR)
   {
      if (output_flag == 1)
         printf("SM_CfgCheckDecSignData: reading from %s\n", fn);
      memset(&bf, 0, sizeof(SM_Buf_file));
      SM_ReadBufFromFile(&bf, fn);
      result.str = bf.data;
      result.lgth = bf.lgth;
      pSignData = (SM_Signed_data *)calloc(1, sizeof(SM_Signed_data));
      /* ASN.1 decode the receipt */
      if (output_flag == 1)
         printf("SM_CfgCheckDecSignData: decoding...\n");
      if ((ret = SM_DecSignData(pSignData, &result,
         &error)) == SM_NO_ERROR)
      {
         if (output_flag = 1)
         {
            printf("SM_CfgCheckDecSignData: printing C structure...\n");
            SM_PrtSignData(pSignData);
         }
         if (output_flag != -1)
            printf("SM_DecSignData returned SM_NO_ERROR\n");
      }
      else
         printf("SM_CfgCheckDecSignData: SM_DecSignData returned %ld\n", ret); 
   }
   else
      printf("SM_CfgCheckDecSignData: missing EncodedSignDataFN kw\n");

   // free?
   SM_SetCfgFn(pszOrigCfgFile);
   return ret;
}
#endif
/* EOF sm_CfgCheckVerify.cpp */
