#ifndef NO_SCCS_ID
static char SccsId[ ] = "@(#) sm_CfgLogins.cpp 1.5 3/27/98 18:37:57"; 
#endif

#include <stdio.h>
#include "sm_util.h"
// INCLUDE all algorithms supported by this test program ("Logins=" keyword).
#include "sm_common.h"
#ifdef SM_FREE_USED
#include "sm_free.h"
#endif

SM_RET_VAL SM_CfgLoginsSection(Section section, CSMIME *pCsmime);

SM_RET_VAL SM_CfgLogins(char *pszCfgFile, CSMIME *pCsmime)
{
    SM_RET_VAL status=SM_NO_ERROR;
    char *pszOrigCfgFile;
    KwValue kwValue;
    char lpszLoginBuf[10];
    int i=1;
    char *ptr;

    if ((ptr=strchr(pszCfgFile, ' ')) ||
        (ptr=strchr(pszCfgFile, '\t'))||
        (ptr=strchr(pszCfgFile, '\r')) ) *ptr = '\0';
    pszOrigCfgFile = SM_SetCfgFn(pszCfgFile); /* set config file */
    sprintf(lpszLoginBuf, "Login%d", i++);
    while (status == SM_NO_ERROR &&     // For each CSInstance login entry
        SM_GetKwValue(lpszLoginBuf, kwValue, "Logins") == SM_NO_ERROR)
    {
        status = SM_CfgLoginsSection(kwValue, pCsmime);
        sprintf(lpszLoginBuf, "Login%d", i++);  // prepare for next keyword.
    }

    SM_SetCfgFn(pszOrigCfgFile); /* set original, incomming config file */

    return status;
}

//////////////////////////////////////////////////////////////////////////
// SM_CfgLoginsSection reads the requested login section and calls the
// init for that section passing the specified parameters.  The intent
// is to add instances to pCsmime...
SM_RET_VAL SM_CfgLoginsSection(Section section, CSMIME *pCsmime)
{
   SM_RET_VAL lStatus = SM_NO_ERROR;
   KwValue szLoginType;
   CSM_Buffer *pTmpBuf=NULL;

   if (SM_GetKwValue("LoginType", szLoginType, section) == SM_NO_ERROR && 
         !strstr(szLoginType, "NULL"))
   {
      if (strcmp(szLoginType, "COMMON") == 0)
      {
         KwValue pszCertFile;
         SM_GetKwValue("PublicKey", pszCertFile, section); 
                                // there may not be a file.
         lStatus = SM_CfgAliasCertFile(pszCertFile, pTmpBuf);
                                        // RESOLVE alias if necessary.
         lStatus = SMCommonInit(pCsmime, pTmpBuf, section); 
                         // SECTION name is ID for COMMON SMTI token.
                         // Create CSInst for CSM_Common token.
       }
#ifdef SM_FREE_USED
       else if (strcmp(szLoginType, "FREE") == 0)
       {
          KwValue szPassword;
          KwValue szAddressBook;
          KwValue szPreffix;

          SM_GetKwValue("Password", szPassword, section);
          SM_GetKwValue("AddressBook", szAddressBook, section);
          SM_GetKwValue("Preffix", szPreffix, section);
          lStatus = SMFreeInit(pCsmime, szPassword, szAddressBook, szPreffix);
       }
#endif
#ifdef SM_FORT_USED
       // code for fortezza CTI init call goes here...
#endif
#ifdef SM_RSA_USED
       // code for rsa CTI init call goes here...
#endif
       // ... more CTIs could be initialized here...
   }
   return lStatus;
}

// EOF SM_CfgLogins.cpp
